package com.jbtravel.domain;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.DiscriminatorColumn;
import javax.persistence.DiscriminatorType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Inheritance(strategy = InheritanceType.SINGLE_TABLE)
@DiscriminatorColumn(name = "FEETYPE", discriminatorType = DiscriminatorType.STRING)
@Table(schema = "jbtravel")
public abstract class Fee implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Integer feeid;

	private BigDecimal amount;

	@ManyToOne
	@JoinColumn(name = "RESERVATIONID")
	private Reservation reservation;

	public Fee() {

	}

	public Fee(BigDecimal amount) {
		this.amount = amount;
	}

	public Integer getFeeid() {
		return feeid;
	}

	public void setFeeid(Integer feeid) {
		this.feeid = feeid;
	}

	public BigDecimal getAmount() {
		return amount;
	}

	public void setAmount(BigDecimal amount) {
		this.amount = amount;
	}

	public Reservation getReservation() {
		return reservation;
	}

	public void setReservation(Reservation reservation) {
		this.reservation = reservation;
	}
	
	public abstract String getFeeType();

}
