package com.jbtravel.rules;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;

import javax.annotation.PostConstruct;
import javax.ejb.Singleton;
import javax.ejb.Startup;

import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;


@Singleton
@Startup
public class RulesEngine  implements Serializable {

	private static final long serialVersionUID = 1L;
	
	private KieContainer container;

	public Collection<Object> fire(Object ... facts) {

		KieSession ksession = container.newKieSession("ComfortSession");

		if (ksession == null)
			throw new IllegalStateException("KIE ComfortSession was not built");
		
		for(Object fact : facts) {
			ksession.insert(fact);
		}
	
		ksession.fireAllRules();
		
		Collection<Object> updatedFacts = new ArrayList<Object>();
		for (Object o : ksession.getObjects())
			updatedFacts.add(o);
		
		ksession.dispose();
		
		return updatedFacts;
	}
	
	@PostConstruct
	public void build(){
		KieServices kieServices = KieServices.Factory.get();
		container = kieServices.newKieClasspathContainer();
		if(RuleUtils.checkErrors(container)){
			throw new IllegalArgumentException("There are rule syntax errors");
		}

	}
	
}
