/*
 Copyright (c) 2012 Red Hat, Inc.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:

   1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following
   disclaimer in the documentation and/or other materials provided
   with the distribution.

 THIS SOFTWARE IS PROVIDED BY RED HAT, INC. ``AS IS'' AND ANY EXPRESS
 OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL RED HAT, INC. BE LIABLE FOR ANY DIRECT,
 INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
 */

package com.jbtravel.beans;

import java.util.List;

import javax.inject.Inject;

import org.junit.Assert;

import org.jboss.arquillian.junit.Arquillian;
import org.junit.Test;
import org.junit.runner.RunWith;

import com.jbtravel.BaseWebTestTemplate;
import com.jbtravel.domain.ValMealtype;

@RunWith(Arquillian.class)
public class MealBeanTest extends BaseWebTestTemplate {

	@Inject
	MealBean mealBean;

	private final static String[] MEAL_TYPES = { "None", "No Preference",
			"Chicken", "Vegetarian", "Kosher" };

	@Test
	public void testGetAll() {
		List<ValMealtype> meals = mealBean.getAll();
		Assert.assertNotNull(meals);
		Assert.assertEquals(MEAL_TYPES.length, meals.size());
		for (String mealType : MEAL_TYPES) {
			boolean found = false;
			for (ValMealtype meal : meals) {
				if (meal.getMeal().equals(mealType)) {
					found = true;
					break;
				}
			}
			if (!found)
				Assert.fail(String.format("Meal type, %s, not found", mealType));
		}
	}
}
