package com.jbtravel.rules;

import static com.jbtravel.rules.RuleUtils.checkErrors;

import org.junit.After;
import org.junit.Before;
import org.kie.api.KieServices;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

public class BaseRulesTestTemplate {

	protected KieSession ksession;
	private String sessionId;
	
	public BaseRulesTestTemplate(String sessionId) {
		this.sessionId = sessionId;
	}
	
	public BaseRulesTestTemplate() {
		this.sessionId = "ComfortSession";
	}

	@Before
	public void createRulesEngine() {
		KieServices services = KieServices.Factory.get();
		
		KieContainer container = services.getKieClasspathContainer();
		if(checkErrors(container)){
			throw new IllegalArgumentException("Rule Errors.");
		}
		ksession = container.newKieSession(sessionId);
	}

	

	@After
	public void shutdownRulesEngine() {
		ksession.dispose();
	}
}
