package com.jbtravel.rules;

import static org.junit.Assert.assertEquals;

import org.junit.Test;
import org.kie.api.runtime.rule.FactHandle;

import com.jbtravel.domain.Flight;
import com.jbtravel.domain.Reservation;
import com.jbtravel.domain.ReservationStatusType;
import com.jbtravel.domain.Route;
import com.jbtravel.domain.User;

public class ReservationRulesTest extends BaseRulesTestTemplate {
	

	@Test
	public void loyaltyNoneTest() {
		
		User user = new User();
		FactHandle fact = ksession.insert(user);
		ksession.fireAllRules();
		User afUser = (User) ksession.getObject(fact);
		assertEquals("None", afUser.getLoyaltylevel());
	}
	
	@Test
	public void loyaltyBronzeTest() {
		
		User user = new User();
		user.setMiles(10001);
		FactHandle fact = ksession.insert(user);
		ksession.fireAllRules();
		User afUser = (User) ksession.getObject(fact);
		assertEquals("Bronze", afUser.getLoyaltylevel());
	}
	
	@Test
	public void loyaltySilverTest() {
		
		User user = new User();
		user.setMiles(25001);
		FactHandle fact = ksession.insert(user);
		ksession.fireAllRules();
		User afUser = (User) ksession.getObject(fact);
		assertEquals("Silver", afUser.getLoyaltylevel());
	}
	
	@Test
	public void loyaltyGoldTest() {
		
		User user = new User();
		user.setMiles(50001);
		FactHandle fact = ksession.insert(user);
		ksession.fireAllRules();
		User afUser = (User) ksession.getObject(fact);
		assertEquals("Gold", afUser.getLoyaltylevel());
	}
	
	@Test
	public void testAssignMiles() {
		Route route = new Route();
		route.setDistance(5000);
		Flight flight = new Flight();
		flight.setRoute(route);
		Reservation reservation = new Reservation();
		reservation.setFlight(flight);
		User user = new User();
		reservation.setUser(user);
		reservation.setStatus(ReservationStatusType.PENDING);
		FactHandle fact = ksession.insert(reservation);
		ksession.fireAllRules();
		Reservation afReservation = (Reservation) ksession.getObject(fact);
		assertEquals("None", afReservation.getUser().getLoyaltylevel());
		assertEquals((Integer) 5000, afReservation.getUser().getMiles());
		
		ksession.delete(fact);
		route.setDistance(6000);
		reservation.setStatus(ReservationStatusType.PENDING);
		fact = ksession.insert(reservation);
		ksession.fireAllRules();
		afReservation = (Reservation) ksession.getObject(fact);
		assertEquals("Bronze", afReservation.getUser().getLoyaltylevel());
		assertEquals((Integer) 11000, afReservation.getUser().getMiles());
	}
}
