/*
 Copyright (c) 2012 Red Hat, Inc.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:

   1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following
   disclaimer in the documentation and/or other materials provided
   with the distribution.

 THIS SOFTWARE IS PROVIDED BY RED HAT, INC. ``AS IS'' AND ANY EXPRESS
 OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL RED HAT, INC. BE LIABLE FOR ANY DIRECT,
 INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
 */

package com.jbtravel.view;

import javax.inject.Inject;

import org.junit.Assert;

import org.jboss.arquillian.junit.Arquillian;
import org.junit.Test;
import org.junit.runner.RunWith;

import com.jbtravel.BaseWebTestTemplate;

@RunWith(Arquillian.class)
public class IdentityTest extends BaseWebTestTemplate {

	@Inject
	Identity identity;

	@Test
	public void testLoginSuccess() {
		Assert.assertTrue(!identity.isLoggedIn());
		identity.getCredentials().setUsername("admin");
		identity.getCredentials().setPassword("admin");
		identity.login();
		Assert.assertTrue(identity.isLoggedIn());
	}

	// This is expected because we don't have a JSF context
	@Test(expected = NullPointerException.class)
	public void testLoginFailure() {
		identity.getCredentials().setUsername("admin");
		identity.getCredentials().setPassword("bogus");
		identity.login();
		Assert.assertTrue(!identity.isLoggedIn());
	}

	@Test
	public void testLogout() {
		testLoginSuccess();
		identity.logout();
		Assert.assertTrue(!identity.isLoggedIn());
	}
}
